<?php

use Tygh\Registry;
use Tygh\Settings;
use Tygh\Http;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

require_once dirname(__FILE__) . "/QuickPay/QuickPay.php";

use QuickPay\QuickPay;

function fn_quickpay_delete_payment_processors()
{
    db_query("DELETE FROM ?:payment_descriptions WHERE payment_id IN (SELECT payment_id FROM ?:payments WHERE processor_id IN (SELECT processor_id FROM ?:payment_processors WHERE processor_script IN ('quickpay.php')))");
    db_query("DELETE FROM ?:payments WHERE processor_id IN (SELECT processor_id FROM ?:payment_processors WHERE processor_script IN ('quickpay.php'))");
    db_query("DELETE FROM ?:payment_processors WHERE processor_script IN ('quickpay.php')");
}

function fn_get_quickpay_card($params) {
   
    $api_key = $params['api_user_key'];
    $client = new QuickPay(":$api_key");
    
    $user_id = $_SESSION['auth']['user_id'];
    $card_id = fn_get_quickpay_card_by_user_id($_SESSION['auth']['user_id']);
    //$card = $client->request->post("/cards/$card_id/cancel");
    //db_query('DELETE FROM ?:quickpay_links WHERE user_id=?i', $user_id);
    //$card_id = '';
    //$link = $client->request->put("/cards/" . $card->id . "/link");
    $url = '';
    $card_data = array();
    if (!empty($user_id)) {
        if (empty($card_id)) {
            $card = $client->request->post("/cards");
            $card_data = $card->asArray();
            $card_id = $card_data['id'];
            if (!empty($card_id)) {
                db_query('INSERT INTO ?:quickpay_links ?e', array('user_id' => $user_id, 'card_id' => $card_id));
                $link = $client->request->put("/cards/$card_id/link");
                $link_data = $link->asArray();
                if (!empty($link_data['url'])) {
                    $url = $link_data['url'];
                }
            } 
        }
        else {
            $card = $client->request->get("/cards/$card_id");
            $card_data = $card->asArray();
            $link = $client->request->put("/cards/$card_id/link");
            $link_data = $link->asArray();
            if (!empty($link_data['url'])) {
                $url = $link_data['url'];
            }
        }
    }
    
    $show_link = false;
    if (!empty($card_data)) {
        if (empty($card_data['accepted'])) {
            $show_link = true;
        }
    }
    
    return array( 'card_data' => $card_data, 'url' => $url, 'show_link' => $show_link);
    
    /*
    //fn_print_r($client);
        
    $payments = $client->request->get('/payments/18743877')->asArray();
    //fn_print_r($payments);
    
    $response = $client->request->get('/ping');
    //fn_print_r($response);
    */
    /*
    $payment = $client->request->post("/payments", array(
        'order_id' => '0011', // Must be unique
        'currency' => 'EUR'
    ))->asObject();
    //fn_print_r($payment);
    //fn_print_r($payment->id);
    
    $link = $client->request->put("/payments/" . $payment->id . "/link", array(
        'amount' => 100 
        //Add ":framed => true" if you want to open the link in an iframe
        )
    );
    */
    ////fn_print_r($link->asArray());
    /*
    $client = new QuickPay(':foo');
    $response = $client->request->get('/ping');
    //fn_print_r($response);
    */
}

function fn_get_quickpay_card_by_user_id($user_id) {
    return db_get_field('SELECT card_id FROM ?:quickpay_links WHERE user_id=?i', $user_id);
}

function fn_get_quickpay_payment_by_order_id($order_id) {
    return db_get_field('SELECT payment_id FROM ?:quickpay_payments WHERE order_id=?i', $order_id);
}

function fn_get_quickpay_payment_methods() {
    return array (
        'creditcard'       => 'Restricting payments to credit card payments only',
        'american-express' => 'American Express credit card',
        'dankort'	   => 'Dankort credit card',
        'diners'	   => 'Diners Club credit card',
        'edankort'	   => 'eDankort credit card',
        'fbg1886'	   => 'Forbrugsforeningen af 1886',
        'jcb'	           => 'JCB credit card',	
        'maestro'	   => 'Maestro debit card',
        'mastercard'	   => 'Mastercard credit card',
        'mastercard-debet' => 'Mastercard debet card',
        'mobilepay'	   => 'MobilePay Online',
        'visa'             => 'Visa credit card',
        'visa-electron'    => 'Visa debet (former Visa Electron) card',
        'paypal'	   => 'PayPal',
        'sofort'	   => 'Sofort',
        'viabill'	   => 'ViaBill',
        'klarna'	   =>'Klarna'       
    );
}

function fn_get_quickpay_currencies() {
    return array(
        'USD',
        'EUR',
        'DKK',
        'NOK',
        'SEK',        
    );
}

function fn_quickpay_sign($params, $api_key) {
    $flattened_params = fn_quickpay_flatten_params($params);
    ksort($flattened_params);
    $base = implode(" ", $flattened_params);

    return hash_hmac("sha256", $base, $api_key);
}

function fn_quickpay_flatten_params($obj, $result = array(), $path = array()) {
    if (is_array($obj)) {
        foreach ($obj as $k => $v) {
            $result = array_merge($result, fn_quickpay_flatten_params($v, $result, array_merge($path, array($k))));
        }
    } else {
        $result[implode("", array_map(function($p) { return "[{$p}]"; }, $path))] = $obj;
    }

    return $result;
}

function fn_get_iso_3_code($iso_2_code) {
    $iso_3 =  array(
        'AD' => 'AND',
        'AE' => 'ARE',
        'AF' => 'AFG',
        'AG' => 'ATG',
        'AI' => 'AIA',
        'AL' => 'ALB',
        'AM' => 'ARM',
        'AN' => 'ANT',
        'AO' => 'AGO',
        'AQ' => 'ATA',
        'AR' => 'ARG',
        'AS' => 'ASM',
        'AT' => 'AUT',
        'AU' => 'AUS',
        'AW' => 'ABW',
        'AX' => 'ALA',
        'AZ' => 'AZE',
        'BA' => 'BIH',
        'BB' => 'BRB',
        'BD' => 'BGD',
        'BE' => 'BEL',
        'BF' => 'BFA',
        'BG' => 'BGR',
        'BH' => 'BHR',
        'BI' => 'BDI',
        'BJ' => 'BEN',
        'BM' => 'BMU',
        'BN' => 'BRN',
        'BO' => 'BOL',
        'BR' => 'BRA',
        'BS' => 'BHS',
        'BT' => 'BTN',
        'BV' => 'BVT',
        'BW' => 'BWA',
        'BY' => 'BLR',
        'BZ' => 'BLZ',
        'CA' => 'CAN',
        'CC' => 'CCK',
        'CD' => 'COD',
        'CF' => 'CAF',
        'CG' => 'COG',
        'CH' => 'CHE',
        'CI' => 'CIV',
        'CK' => 'COK',
        'CL' => 'CHL',
        'CM' => 'CMR',
        'CN' => 'CHN',
        'CO' => 'COL',
        'CR' => 'CRI',
        'CS' => 'SCG',
        'CU' => 'CUB',
        'CV' => 'CPV',
        'CX' => 'CXR',
        'CY' => 'CYP',
        'CZ' => 'CZE',
        'DE' => 'DEU',
        'DJ' => 'DJI',
        'DK' => 'DNK',
        'DM' => 'DMA',
        'DO' => 'DOM',
        'DZ' => 'DZA',
        'EC' => 'ECU',
        'EE' => 'EST',
        'EG' => 'EGY',
        'EH' => 'ESH',
        'ER' => 'ERI',
        'ES' => 'ESP',
        'ET' => 'ETH',
        'FI' => 'FIN',
        'FJ' => 'FJI',
        'FK' => 'FLK',
        'FM' => 'FSM',
        'FO' => 'FRO',
        'FR' => 'FRA',
        'GA' => 'GAB',
        'GB' => 'GBR',
        'GD' => 'GRD',
        'GE' => 'GEO',
        'GF' => 'GUF',
        'GH' => 'GHA',
        'GI' => 'GIB',
        'GL' => 'GRL',
        'GM' => 'GMB',
        'GN' => 'GIN',
        'GP' => 'GLP',
        'GQ' => 'GNQ',
        'GR' => 'GRC',
        'GS' => 'SGS',
        'GT' => 'GTM',
        'GU' => 'GUM',
        'GW' => 'GNB',
        'GY' => 'GUY',
        'HK' => 'HKG',
        'HM' => 'HMD',
        'HN' => 'HND',
        'HR' => 'HRV',
        'HT' => 'HTI',
        'HU' => 'HUN',
        'ID' => 'IDN',
        'IE' => 'IRL',
        'IL' => 'ISR',
        'IN' => 'IND',
        'IO' => 'IOT',
        'IQ' => 'IRQ',
        'IR' => 'IRN',
        'IS' => 'ISL',
        'IT' => 'ITA',
        'JM' => 'JAM',
        'JO' => 'JOR',
        'JP' => 'JPN',
        'KE' => 'KEN',
        'KG' => 'KGZ',
        'KH' => 'KHM',
        'KI' => 'KIR',
        'KM' => 'COM',
        'KN' => 'KNA',
        'KP' => 'PRK',
        'KR' => 'KOR',
        'KW' => 'KWT',
        'KY' => 'CYM',
        'KZ' => 'KAZ',
        'LA' => 'LAO',
        'LB' => 'LBN',
        'LC' => 'LCA',
        'LI' => 'LIE',
        'LK' => 'LKA',
        'LR' => 'LBR',
        'LS' => 'LSO',
        'LT' => 'LTU',
        'LU' => 'LUX',
        'LV' => 'LVA',
        'LY' => 'LBY',
        'MA' => 'MAR',
        'MC' => 'MCO',
        'MD' => 'MDA',
        'MG' => 'MDG',
        'MH' => 'MHL',
        'MK' => 'MKD',
        'ML' => 'MLI',
        'MM' => 'MMR',
        'MN' => 'MNG',
        'MO' => 'MAC',
        'MP' => 'MNP',
        'MQ' => 'MTQ',
        'MR' => 'MRT',
        'MS' => 'MSR',
        'MT' => 'MLT',
        'MU' => 'MUS',
        'MV' => 'MDV',
        'MW' => 'MWI',
        'MX' => 'MEX',
        'MY' => 'MYS',
        'MZ' => 'MOZ',
        'NA' => 'NAM',
        'NC' => 'NCL',
        'NE' => 'NER',
        'NF' => 'NFK',
        'NG' => 'NGA',
        'NI' => 'NIC',
        'NL' => 'NLD',
        'NO' => 'NOR',
        'NP' => 'NPL',
        'NR' => 'NRU',
        'NU' => 'NIU',
        'NZ' => 'NZL',
        'OM' => 'OMN',
        'PA' => 'PAN',
        'PE' => 'PER',
        'PF' => 'PYF',
        'PG' => 'PNG',
        'PH' => 'PHL',
        'PK' => 'PAK',
        'PL' => 'POL',
        'PM' => 'SPM',
        'PN' => 'PCN',
        'PR' => 'PRI',
        'PS' => 'PSE',
        'PT' => 'PRT',
        'PW' => 'PLW',
        'PY' => 'PRY',
        'QA' => 'QAT',
        'RE' => 'REU',
        'RO' => 'ROU',
        'RU' => 'RUS',
        'RW' => 'RWA',
        'SA' => 'SAU',
        'SB' => 'SLB',
        'SC' => 'SYC',
        'SD' => 'SDN',
        'SE' => 'SWE',
        'SG' => 'SGP',
        'SH' => 'SHN',
        'SI' => 'SVN',
        'SJ' => 'SJM',
        'SK' => 'SVK',
        'SL' => 'SLE',
        'SM' => 'SMR',
        'SN' => 'SEN',
        'SO' => 'SOM',
        'SR' => 'SUR',
        'ST' => 'STP',
        'SV' => 'SLV',
        'SY' => 'SYR',
        'SZ' => 'SWZ',
        'TC' => 'TCA',
        'TD' => 'TCD',
        'TF' => 'ATF',
        'TG' => 'TGO',
        'TH' => 'THA',
        'TJ' => 'TJK',
        'TK' => 'TKL',
        'TL' => 'TLS',
        'TM' => 'TKM',
        'TN' => 'TUN',
        'TO' => 'TON',
        'TR' => 'TUR',
        'TT' => 'TTO',
        'TV' => 'TUV',
        'TW' => 'TWN',
        'TZ' => 'TZA',
        'UA' => 'UKR',
        'UG' => 'UGA',
        'UM' => 'UMI',
        'US' => 'USA',
        'UY' => 'URY',
        'UZ' => 'UZB',
        'VA' => 'VAT',
        'VC' => 'VCT',
        'VE' => 'VEN',
        'VG' => 'VGB',
        'VI' => 'VIR',
        'VN' => 'VNM',
        'VU' => 'VUT',
        'WF' => 'WLF',
        'WS' => 'WSM',
        'YE' => 'YEM',
        'YT' => 'MYT',
        'ZA' => 'ZAF',
        'ZM' => 'ZMB',
        'ZW' => 'ZWE'
    );
    return $iso_3[$iso_2_code];
}